package com.zcloud.personnel.positioning.web;

import com.zcloud.personnel.positioning.api.SyncLogServiceI;
import com.zcloud.personnel.positioning.dto.SyncLogAddCmd;
import com.zcloud.personnel.positioning.dto.SyncLogPageQry;
import com.zcloud.personnel.positioning.dto.SyncLogUpdateCmd;
import com.zcloud.personnel.positioning.dto.clientobject.SyncLogCO;
import com.alibaba.cola.dto.MultiResponse;
import com.alibaba.cola.dto.PageResponse;
import com.alibaba.cola.dto.Response;
import com.alibaba.cola.dto.SingleResponse;
import com.jjb.saas.framework.auth.model.SSOUser;
import com.jjb.saas.framework.auth.utils.AuthContext;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * web-adapter
 *
 * @Author fangjiakai
 * @Date 2026-07-07
 */
@Api(tags = "人员定位同步日志")
@RequestMapping("/${application.gateway}/syncLog")
@RestController
@AllArgsConstructor
public class SyncLogController {
    private final SyncLogServiceI syncLogService;

    @ApiOperation("新增")
    @PostMapping("/save")
    public SingleResponse<SyncLogCO> add(@Validated @RequestBody SyncLogAddCmd cmd) {
        fillCorpinfo(cmd);
        return syncLogService.add(cmd);
    }

    @ApiOperation("分页")
    @PostMapping("/list")
    public PageResponse<SyncLogCO> page(@RequestBody SyncLogPageQry qry) {
        return syncLogService.listPage(qry);
    }

    @ApiOperation("所有数据")
    @GetMapping("/listAll")
    public MultiResponse<SyncLogCO> listAll() {
        return MultiResponse.of(syncLogService.listAll());
    }

    @ApiOperation("详情")
    @GetMapping("/{id}")
    public SingleResponse<SyncLogCO> getInfoById(@PathVariable("id") Long id) {
        return SingleResponse.of(syncLogService.queryById(id));
    }

    @ApiOperation("删除")
    @DeleteMapping("/{id}")
    public Response remove(@PathVariable("id") Long id) {
        syncLogService.remove(id);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("删除多个")
    @DeleteMapping("/ids")
    public Response removeBatch(@RequestParam Long[] ids) {
        syncLogService.removeBatch(ids);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("修改")
    @PutMapping("/edit")
    public SingleResponse edit(@Validated @RequestBody SyncLogUpdateCmd cmd) {
        fillCorpinfo(cmd);
        syncLogService.edit(cmd);
        return SingleResponse.buildSuccess();
    }

    private void fillCorpinfo(SyncLogAddCmd cmd) {
        SSOUser ssoUser = AuthContext.getCurrentUser();
        if (ssoUser != null && ssoUser.getCompanyId() != null) {
            cmd.setCorpinfoId(String.valueOf(ssoUser.getCompanyId()));
        }
    }

    private void fillCorpinfo(SyncLogUpdateCmd cmd) {
        SSOUser ssoUser = AuthContext.getCurrentUser();
        if (ssoUser != null && ssoUser.getCompanyId() != null) {
            cmd.setCorpinfoId(String.valueOf(ssoUser.getCompanyId()));
        }
    }
}
